package org.cesar.flip.flipex.validators;

import org.cesar.flip.flipex.RefactoringInfo;

/**
 * Base class to all validators.<BR>
 * <BR>
 * 
 * Clients who wish to extend the FLIP platform by adding validators that will
 * be used by new extractors should subclass this class and implement the
 * <code>validateOrigin</code> and <code>validateDestination</code> method.
 * 
 * @author Davi Pires (davi.pires@cesar.org.br)
 * 
 */
public abstract class Validator implements IValidator {
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.cesar.flip.flipex.validators.IValidator#validateOrigin(org.cesar.flip.flipex.RefactoringInfo)
	 */
	public abstract ValidatorStatus validateOrigin(
			RefactoringInfo refactoringInfo);

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.cesar.flip.flipex.validators.IValidator#validateDestination(org.cesar.flip.flipex.RefactoringInfo)
	 */
	public abstract ValidatorStatus validateDestination(
			RefactoringInfo refactoringInfo);
}
