package org.cesar.flip.flipg;

import java.util.HashMap;
import java.util.Map;

import org.cesar.flip.flipg.model.IComponent;
import org.cesar.flip.flipg.model.IComponentFactory;

public class AbstractComponentFactory {
	private Map<String, IComponentFactory> typeToFactory = new HashMap<String, IComponentFactory>();

	public IComponent createComponent(String componentType) {
		IComponent component = null;
		if (this.typeToFactory.containsKey(componentType)) {
			return this.typeToFactory.get(componentType).createComponent(
					componentType);
		}
		return component;
	}

	public void registerFactory(IComponentFactory factory) {
		for (String componentType : factory.getAvaliableComponents()) {
			this.typeToFactory.put(componentType, factory);
		}
	}
}
