package org.cesar.flip.flipg.model;

/**
 * Interface representing a variation solver (eg. aspects, ajats templates,
 * etc).
 * 
 * @author Andrea Menezes  andrea.menezes@cesar.org.br
 * @author Fernando Calheiros  fernando.calheiros@cesar.org.br
 * @author Geraldo Fernandes  geraldo.fernandes@cesar.org.br
 * @author Vilmar Nepomuceno  vilmar.nepomuceno@cesar.org.br
 */
public interface IVariationSolver {

	/**
	 * Returns the name of variation solver (without the path).
	 * 
	 * @return The name of variation solver.
	 */
	public String getName();

	/**
	 * Returns the absolute path of variation solver.
	 * 
	 * @return The absolute path of variation solver.
	 */
	public String getPath();

	/**
	 * Returns the text that represents the variation solver for storing in the
	 * configuration knowledge.
	 * 
	 * @return the text that represents the variation solver for storing in the
	 *         configuration knowledge
	 */
	public String getStorageText();
}
