package org.cesar.flip.flipg.model.expressions;

import java.util.List;

import org.cesar.flip.FlipPlugin;
import org.cesar.flip.flipg.model.IExpression;
import org.cesar.flip.flipg.model.IFeature;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

public class NodeFactory {
	private List<IFeature> features;

	public NodeFactory(List<IFeature> features) {
		this.features = features;
	}

	public AndExpression createAndExpression(IExpression lhs, IExpression rhs) {
		return new AndExpression(lhs, rhs);
	}

	public OrExpression createOrExpression(IExpression lhs, IExpression rhs) {
		return new OrExpression(lhs, rhs);
	}

	public NotExpression createNotExpression(IExpression exp) {
		return new NotExpression(exp);
	}

	public IExpression createFeature(String name) throws Exception {
		IFeature selectedFeature = null;
		for (IFeature feature : this.features) {
			if (feature.getName().equals(name)) {
				selectedFeature = feature;
				break;
			}
		}
		if (selectedFeature == null) {
			Status status = new Status(IStatus.ERROR, FlipPlugin.PLUGIN_ID,
					"No feature with the given name: " + name + ".");
			throw new CoreException(status);
		}
		return selectedFeature;
	}
}
