package org.cesar.flip.flipg.model.expressions;

import org.cesar.flip.flipg.model.IExpression;

public class OrExpression implements IExpression {

	private IExpression lhs;

	private IExpression rhs;

	public IExpression getLhs() {
		return this.lhs;
	}

	public IExpression getRhs() {
		return this.rhs;
	}

	public OrExpression(IExpression lhs, IExpression rhs) {
		this.lhs = lhs;
		this.rhs = rhs;
	}

	public String getCode() {
		return "(" + this.lhs.getCode() + " or " + this.rhs.getCode() + ")";
	}

	@Override
	public String toString() {
		return this.getCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		return (obj instanceof OrExpression)
				&& (((OrExpression) obj).getCode().equals(this.getCode()));
	}

	public void accept(ExpressionVisitor visitor) {
		visitor.visitOrExpression(this);
	}
}
